diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/model/random-variable-stream.cc ns-3.33/src/core/model/random-variable-stream.cc
--- ns-3.32/src/core/model/random-variable-stream.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/model/random-variable-stream.cc	2021-01-09 10:19:22.000000000 -0800
@@ -705,7 +705,11 @@
   if (m_nextValid)
     { // use previously generated
       m_nextValid = false;
-      return m_next;
+      double x2 = mean + m_v2 * m_y * std::sqrt (variance);
+      if (std::fabs (x2 - mean) <= bound)
+        {
+          return x2;
+        }
     }
   while (1)
     { // See Simulation Modeling and Analysis p. 466 (Averill Law)
@@ -724,20 +728,21 @@
       if (w <= 1.0)
         { // Got good pair
           double y = std::sqrt ((-2 * std::log (w)) / w);
-          m_next = mean + v2 * y * std::sqrt (variance);
-          // if next is in bounds, it is valid
-          m_nextValid = std::fabs (m_next - mean) <= bound;
           double x1 = mean + v1 * y * std::sqrt (variance);
-          // if x1 is in bounds, return it
+          // if x1 is in bounds, return it, cache v2 and y
           if (std::fabs (x1 - mean) <= bound)
             {
+              m_nextValid = true;
+              m_y = y;
+              m_v2 = v2;
               return x1;
             }
-          // otherwise try and return m_next if it is valid
-          else if (m_nextValid)
+          // otherwise try and return the other if it is valid
+          double x2 = mean + v2 * y * std::sqrt (variance);
+          if (std::fabs (x2 - mean) <= bound)
             {
               m_nextValid = false;
-              return m_next;
+              return x2;
             }
           // otherwise, just run this loop again
         }
@@ -1021,7 +1026,11 @@
   if (m_nextValid)
     { // use previously generated
       m_nextValid = false;
-      return m_next;
+      double x2 = mean + m_v2 * m_y * std::sqrt (variance);
+      if (std::fabs (x2 - mean) <= bound)
+        {
+          return x2;
+        }
     }
   while (1)
     { // See Simulation Modeling and Analysis p. 466 (Averill Law)
@@ -1040,20 +1049,21 @@
       if (w <= 1.0)
         { // Got good pair
           double y = std::sqrt ((-2 * std::log (w)) / w);
-          m_next = mean + v2 * y * std::sqrt (variance);
-          // if next is in bounds, it is valid
-          m_nextValid = std::fabs (m_next - mean) <= bound;
           double x1 = mean + v1 * y * std::sqrt (variance);
-          // if x1 is in bounds, return it
+          // if x1 is in bounds, return it, cache v2 an y
           if (std::fabs (x1 - mean) <= bound)
             {
+              m_nextValid = true;
+              m_y = y;
+              m_v2 = v2;
               return x1;
             }
-          // otherwise try and return m_next if it is valid
-          else if (m_nextValid)
+          // otherwise try and return the other if it is valid
+          double x2 = mean + v2 * y * std::sqrt (variance);
+          if (std::fabs (x2 - mean) <= bound)
             {
               m_nextValid = false;
-              return m_next;
+              return x2;
             }
           // otherwise, just run this loop again
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/model/random-variable-stream.h ns-3.33/src/core/model/random-variable-stream.h
--- ns-3.32/src/core/model/random-variable-stream.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/model/random-variable-stream.h	2021-01-09 10:19:22.000000000 -0800
@@ -1240,8 +1240,10 @@
   /** True if the next value is valid. */
   bool m_nextValid;
 
-  /** The algorithm produces two values at a time. */
-  double m_next;
+  /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+  double m_v2;
+  /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+  double m_y;
 
 };  // class NormalRandomVariable
 
@@ -1634,8 +1636,10 @@
   /** True if the next normal value is valid. */
   bool m_nextValid;
 
-  /** The algorithm produces two normal values at a time. */
-  double m_next;
+  /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+  double m_v2;
+  /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+  double m_y;
 
 };  // class GammaRandomVariable
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/model/show-progress.h ns-3.33/src/core/model/show-progress.h
--- ns-3.32/src/core/model/show-progress.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/model/show-progress.h	2021-01-09 10:19:22.000000000 -0800
@@ -48,9 +48,14 @@
  *
  * Print a status message showing the simulator time and
  * execution speed, relative to wall clock time, as well as the number
- * of events executed each interval.
+ * of events executed each interval of wall clock time.
  *
- * The target update rate (and output stream) can be configured at construction.
+ * The output interval is based on wall clock time, rather than simulation
+ * time, to avoid too many events for fast simulations, and too long of
+ * a reporting interval for very slow simulations.
+ *
+ * The target update interval (and output stream) can be configured
+ * at construction.  The default output stream, if unspecified, is cout.
  *
  * Example usage:
  *
@@ -59,7 +64,7 @@
  *     {
  *       // Create your model
  *
- *       ShowProgress (Seconds (1), std::cerr);
+ *       ShowProgress progress (Seconds (10), std::cerr);
  *       Simulator::Run ();
  *       Simulator::Destroy ();
  *     }
@@ -80,9 +85,12 @@
  *     Elapsed wall clock: 16s
  * \endcode
  *
+ * A more extensive example of use is provided in sample-show-progress.cc.
+ *
  * Based on a python version by Gustavo Carneiro <gjcarneiro@gmail.com>,
  * as released here:
- * http://mailman.isi.edu/pipermail/ns-developers/2009-January/005201.html
+ * 
+ * https://mailman.isi.edu/pipermail/ns-developers/2009-January/005039.html
  */
 class ShowProgress
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/model/time.cc ns-3.33/src/core/model/time.cc
--- ns-3.32/src/core/model/time.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/model/time.cc	2021-01-09 10:19:22.000000000 -0800
@@ -23,7 +23,7 @@
 #include "abort.h"
 #include "system-mutex.h"
 #include "log.h"
-#include <cmath>
+#include <cmath>    // pow
 #include <iomanip>  // showpos
 #include <sstream>
 
@@ -38,6 +38,49 @@
 
 NS_LOG_COMPONENT_DEFINE_MASK ("Time", ns3::LOG_PREFIX_TIME);
 
+/** Unnamed namespace */
+namespace {
+
+  /** Scaling coefficients, exponents, and look up table for unit. */
+  /** @{ */
+  /** Scaling exponent, relative to smallest unit. */
+  //                                      Y,   D,  H, MIN,  S, MS, US, NS, PS, FS
+  const int8_t  UNIT_POWER[Time::LAST] = {     17,  17, 17,  16, 15, 12,  9,  6,  3,  0 };
+  /** Scaling coefficient, relative to smallest unit. */
+  const int32_t UNIT_COEFF[Time::LAST] = { 315360, 864, 36,   6,  1,  1,  1,  1,  1,  1 };
+
+
+  /**
+   * Scale a unit to the smallest unit.
+   * \param u The unit to scale
+   * \returns The value of \pname{u} in terms of the smallest defined unit.
+   */
+  long double
+  Scale (Time::Unit u)
+  {
+    return UNIT_COEFF[u] * std::pow (10L, UNIT_POWER[u]); 
+  }
+
+  /** Initializer for \c UNIT_VALUE */
+  long double *
+  InitUnitValue (void)
+  {
+    static long double values[Time::LAST];
+    for (auto u = static_cast<int> (Time::Y); u != static_cast<int> (Time::LAST); ++u)
+      {
+        values [u] = Scale (static_cast<Time::Unit> (u));
+      }
+    return values;
+  }
+
+  /** Value of each unit, in terms of the smallest defined unit. */
+  const long double * UNIT_VALUE = InitUnitValue ();
+
+  /** @} */
+
+}  // unnamed namespace
+
+
 // The set of marked times
 // static
 Time::MarkedTimes * Time::g_markingTimes = 0;
@@ -197,29 +240,26 @@
       ConvertTimes (unit);
     }
 
-  // Y, D, H, MIN, S, MS, US, NS, PS, FS
-  const int8_t power[LAST] = { 17, 17, 17, 16, 15, 12, 9, 6, 3, 0 };
-  const int32_t coefficient[LAST] = { 315360, 864, 36, 6, 1, 1, 1, 1, 1, 1 };
   for (int i = 0; i < Time::LAST; i++)
     {
-      int shift = power[i] - power[(int)unit];
+      int shift = UNIT_POWER[i] - UNIT_POWER[(int)unit];
       int quotient = 1;
-      if (coefficient[i] > coefficient[(int) unit])
+      if (UNIT_COEFF[i] > UNIT_COEFF[(int) unit])
         {
-          quotient = coefficient[i] / coefficient[(int) unit];
-          NS_ASSERT (quotient * coefficient[(int) unit] == coefficient[i]);
+          quotient = UNIT_COEFF[i] / UNIT_COEFF[(int) unit];
+          NS_ASSERT (quotient * UNIT_COEFF[(int) unit] == UNIT_COEFF[i]);
         }
-      else if (coefficient[i] < coefficient[(int) unit])
+      else if (UNIT_COEFF[i] < UNIT_COEFF[(int) unit])
         {
-          quotient = coefficient[(int) unit] / coefficient[i];
-          NS_ASSERT (quotient * coefficient[i] == coefficient[(int) unit]);
+          quotient = UNIT_COEFF[(int) unit] / UNIT_COEFF[i];
+          NS_ASSERT (quotient * UNIT_COEFF[i] == UNIT_COEFF[(int) unit]);
         }
       NS_LOG_DEBUG ("SetResolution for unit " << (int) unit <<
                     " loop iteration " << i <<
                     " has shift " << shift << " has quotient " << quotient);
       int64_t factor = static_cast<int64_t> (std::pow (10, std::fabs (shift)) * quotient);
       double realFactor = std::pow (10, (double) shift)
-        * static_cast<double> (coefficient[i]) / coefficient[(int) unit];
+        * static_cast<double> (UNIT_COEFF[i]) / UNIT_COEFF[(int) unit];
       NS_LOG_DEBUG ("SetResolution factor " << factor << " real factor " << realFactor);
       struct Information *info = &resolution->info[i];
       info->factor = factor;
@@ -386,7 +426,7 @@
 
 
 TimeWithUnit
-Time::As (const enum Unit unit) const
+Time::As (const enum Unit unit /* = Time::AUTO */) const
 {
   return TimeWithUnit (*this, unit);
 }
@@ -403,41 +443,62 @@
 std::ostream &
 operator << (std::ostream & os, const TimeWithUnit & timeU)
 {
-  std::string unit;
 
-  switch (timeU.m_unit)
+  std::string label;
+  Time::Unit unit = timeU.m_unit;
+
+  if (unit == Time::AUTO)
+    {
+      long double value = static_cast<long double> (timeU.m_time.GetTimeStep ());
+      // convert to finest scale (fs)
+      value *= Scale (Time::GetResolution ());
+      // find the best unit
+      int u = Time::Y;
+      while (u != Time::LAST && UNIT_VALUE[u] > value)
+        {
+          ++u;
+        }
+      if (u == Time::LAST)
+        {
+          --u;
+        }
+      unit = static_cast<Time::Unit> (u);
+    }
+
+  switch (unit)
     {
       // *NS_CHECK_STYLE_OFF*
-    case Time::Y:    unit = "y";    break;
-    case Time::D:    unit = "d";    break;
-    case Time::H:    unit = "h";    break;
-    case Time::MIN:  unit = "min";  break;
-    case Time::S:    unit = "s";    break;
-    case Time::MS:   unit = "ms";   break;
-    case Time::US:   unit = "us";   break;
-    case Time::NS:   unit = "ns";   break;
-    case Time::PS:   unit = "ps";   break;
-    case Time::FS:   unit = "fs";   break;
+    case Time::Y:    label = "y";    break;
+    case Time::D:    label = "d";    break;
+    case Time::H:    label = "h";    break;
+    case Time::MIN:  label = "min";  break;
+    case Time::S:    label = "s";    break;
+    case Time::MS:   label = "ms";   break;
+    case Time::US:   label = "us";   break;
+    case Time::NS:   label = "ns";   break;
+    case Time::PS:   label = "ps";   break;
+    case Time::FS:   label = "fs";   break;
       // *NS_CHECK_STYLE_ON*
 
     case Time::LAST:
+    case Time::AUTO:
     default:
       NS_ABORT_MSG ("can't be reached");
-      unit = "unreachable";
+      label = "unreachable";
       break;
     }
 
-  double v = timeU.m_time.ToDouble (timeU.m_unit);
+  double v = timeU.m_time.ToDouble (unit);
 
   // Note: we must copy the "original" format flags because we have to modify them.
   // std::ios_base::showpos is to print the "+" in front of the number for positive,
   // std::ios_base::right is to add (eventual) extra space in front of the number.
   //   the eventual extra space might be due to a std::setw (_number_), and
-  //   normally it would be printed after the number and before the time unit.
+  //   normally it would be printed after the number and before the time unit label.
 
   std::ios_base::fmtflags ff = os.flags ();
 
-  os << std::showpos << std::right << v << unit;
+  os << std::showpos << std::right << v << label;
 
   // And here we have to restore what we changed.
   if (!(ff & std::ios_base::showpos))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/test/int64x64-test-suite.cc ns-3.33/src/core/test/int64x64-test-suite.cc
--- ns-3.32/src/core/test/int64x64-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/test/int64x64-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -187,6 +187,68 @@
 }
 
 
+class Int64x64IntRoundTestCase : public TestCase
+{
+public:
+  Int64x64IntRoundTestCase (void);
+  virtual void DoRun (void);
+  void Check (const int64x64_t value,
+              const int64_t expectInt,
+              const int64_t expectRnd);
+};
+
+Int64x64IntRoundTestCase::Int64x64IntRoundTestCase (void)
+  : TestCase ("Check GetInt and Round")
+{}
+
+void
+Int64x64IntRoundTestCase::Check (const int64x64_t value,
+                                 const int64_t expectInt,
+                                 const int64_t expectRnd)
+{
+  int64_t vInt = value.GetInt ();
+  int64_t vRnd = value.Round ();
+
+  bool pass = (vInt == expectInt) && (vRnd == expectRnd);
+  std::cout << GetParent ()->GetName () << " Check: "
+            << (pass ? "pass " : "FAIL ")
+            << value
+            << " (int)-> " << std::setw (2) << vInt << " (expected: " << std::setw (2) << expectInt
+            << "), (rnd)-> " << std::setw (2) << vRnd << " (expected " << std::setw (2) << expectRnd
+            << ")"
+            << std::endl;
+
+  NS_TEST_EXPECT_MSG_EQ (vInt, expectInt,
+                         "Truncation to int failed");
+  NS_TEST_EXPECT_MSG_EQ (vRnd, expectRnd,
+                         "Rounding to int failed.");
+}
+
+void
+Int64x64IntRoundTestCase::DoRun (void)
+{
+  std::cout << std::endl;
+  std::cout << GetParent ()->GetName () << " Check: " << GetName ()
+            << std::endl;
+
+  // Trivial cases
+  Check ( 0,    0,  0);
+  Check ( 1,    1,  1);
+  Check (-1,   -1, -1);
+
+  // Both should move toward zero
+  Check ( 2.4,  2,  2);
+  Check (-2.4, -2, -2);
+
+  // GetInt should move toward zero; Round should move away
+  Check ( 3.6,  3,  4);
+  Check (-3.6, -3, -4);
+  // Boundary case
+  Check ( 4.5,  4,  5);
+  Check (-4.5, -4, -5);
+}
+
+
 class Int64x64InputTestCase : public TestCase
 {
 public:
@@ -1224,6 +1286,7 @@
   {
     AddTestCase (new Int64x64ImplTestCase (), TestCase::QUICK);
     AddTestCase (new Int64x64HiLoTestCase (), TestCase::QUICK);
+    AddTestCase (new Int64x64IntRoundTestCase (), TestCase::QUICK);
     AddTestCase (new Int64x64ArithmeticTestCase (), TestCase::QUICK);
     AddTestCase (new Int64x64CompareTestCase (), TestCase::QUICK);
     AddTestCase (new Int64x64InputTestCase (), TestCase::QUICK);
